// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use crate::ffi;
use glib::{bitflags::bitflags, prelude::*, translate::*};

bitflags! {
    #[derive(Clone, Copy, Debug, PartialEq, Eq, Hash)]
    #[doc(alias = "AsCacheFlags")]
    pub struct CacheFlags: u32 {
        #[doc(alias = "AS_CACHE_FLAG_NONE")]
        const NONE = ffi::AS_CACHE_FLAG_NONE as _;
        #[doc(alias = "AS_CACHE_FLAG_USE_USER")]
        const USE_USER = ffi::AS_CACHE_FLAG_USE_USER as _;
        #[doc(alias = "AS_CACHE_FLAG_USE_SYSTEM")]
        const USE_SYSTEM = ffi::AS_CACHE_FLAG_USE_SYSTEM as _;
        #[doc(alias = "AS_CACHE_FLAG_NO_CLEAR")]
        const NO_CLEAR = ffi::AS_CACHE_FLAG_NO_CLEAR as _;
        #[doc(alias = "AS_CACHE_FLAG_REFRESH_SYSTEM")]
        const REFRESH_SYSTEM = ffi::AS_CACHE_FLAG_REFRESH_SYSTEM as _;
    }
}

#[doc(hidden)]
impl IntoGlib for CacheFlags {
    type GlibType = ffi::AsCacheFlags;

    #[inline]
    fn into_glib(self) -> ffi::AsCacheFlags {
        self.bits()
    }
}

#[doc(hidden)]
impl FromGlib<ffi::AsCacheFlags> for CacheFlags {
    #[inline]
    unsafe fn from_glib(value: ffi::AsCacheFlags) -> Self {
        skip_assert_initialized!();
        Self::from_bits_truncate(value)
    }
}

impl StaticType for CacheFlags {
    #[inline]
    #[doc(alias = "as_cache_flags_get_type")]
    fn static_type() -> glib::Type {
        unsafe { from_glib(ffi::as_cache_flags_get_type()) }
    }
}

impl glib::HasParamSpec for CacheFlags {
    type ParamSpec = glib::ParamSpecFlags;
    type SetValue = Self;
    type BuilderFn = fn(&str) -> glib::ParamSpecFlagsBuilder<Self>;

    fn param_spec_builder() -> Self::BuilderFn {
        Self::ParamSpec::builder
    }
}

impl glib::value::ValueType for CacheFlags {
    type Type = Self;
}

unsafe impl<'a> glib::value::FromValue<'a> for CacheFlags {
    type Checker = glib::value::GenericValueTypeChecker<Self>;

    #[inline]
    unsafe fn from_value(value: &'a glib::Value) -> Self {
        skip_assert_initialized!();
        from_glib(glib::gobject_ffi::g_value_get_flags(value.to_glib_none().0))
    }
}

impl ToValue for CacheFlags {
    #[inline]
    fn to_value(&self) -> glib::Value {
        let mut value = glib::Value::for_value_type::<Self>();
        unsafe {
            glib::gobject_ffi::g_value_set_flags(value.to_glib_none_mut().0, self.into_glib());
        }
        value
    }

    #[inline]
    fn value_type(&self) -> glib::Type {
        Self::static_type()
    }
}

impl From<CacheFlags> for glib::Value {
    #[inline]
    fn from(v: CacheFlags) -> Self {
        skip_assert_initialized!();
        ToValue::to_value(&v)
    }
}

bitflags! {
    #[derive(Clone, Copy, Debug, PartialEq, Eq, Hash)]
    #[doc(alias = "AsDataIdMatchFlags")]
    pub struct DataIdMatchFlags: u32 {
        #[doc(alias = "AS_DATA_ID_MATCH_FLAG_NONE")]
        const NONE = ffi::AS_DATA_ID_MATCH_FLAG_NONE as _;
        #[doc(alias = "AS_DATA_ID_MATCH_FLAG_SCOPE")]
        const SCOPE = ffi::AS_DATA_ID_MATCH_FLAG_SCOPE as _;
        #[doc(alias = "AS_DATA_ID_MATCH_FLAG_BUNDLE_KIND")]
        const BUNDLE_KIND = ffi::AS_DATA_ID_MATCH_FLAG_BUNDLE_KIND as _;
        #[doc(alias = "AS_DATA_ID_MATCH_FLAG_ORIGIN")]
        const ORIGIN = ffi::AS_DATA_ID_MATCH_FLAG_ORIGIN as _;
        #[doc(alias = "AS_DATA_ID_MATCH_FLAG_ID")]
        const ID = ffi::AS_DATA_ID_MATCH_FLAG_ID as _;
        #[doc(alias = "AS_DATA_ID_MATCH_FLAG_BRANCH")]
        const BRANCH = ffi::AS_DATA_ID_MATCH_FLAG_BRANCH as _;
    }
}

#[doc(hidden)]
impl IntoGlib for DataIdMatchFlags {
    type GlibType = ffi::AsDataIdMatchFlags;

    #[inline]
    fn into_glib(self) -> ffi::AsDataIdMatchFlags {
        self.bits()
    }
}

#[doc(hidden)]
impl FromGlib<ffi::AsDataIdMatchFlags> for DataIdMatchFlags {
    #[inline]
    unsafe fn from_glib(value: ffi::AsDataIdMatchFlags) -> Self {
        skip_assert_initialized!();
        Self::from_bits_truncate(value)
    }
}

impl StaticType for DataIdMatchFlags {
    #[inline]
    #[doc(alias = "as_data_id_match_flags_get_type")]
    fn static_type() -> glib::Type {
        unsafe { from_glib(ffi::as_data_id_match_flags_get_type()) }
    }
}

impl glib::HasParamSpec for DataIdMatchFlags {
    type ParamSpec = glib::ParamSpecFlags;
    type SetValue = Self;
    type BuilderFn = fn(&str) -> glib::ParamSpecFlagsBuilder<Self>;

    fn param_spec_builder() -> Self::BuilderFn {
        Self::ParamSpec::builder
    }
}

impl glib::value::ValueType for DataIdMatchFlags {
    type Type = Self;
}

unsafe impl<'a> glib::value::FromValue<'a> for DataIdMatchFlags {
    type Checker = glib::value::GenericValueTypeChecker<Self>;

    #[inline]
    unsafe fn from_value(value: &'a glib::Value) -> Self {
        skip_assert_initialized!();
        from_glib(glib::gobject_ffi::g_value_get_flags(value.to_glib_none().0))
    }
}

impl ToValue for DataIdMatchFlags {
    #[inline]
    fn to_value(&self) -> glib::Value {
        let mut value = glib::Value::for_value_type::<Self>();
        unsafe {
            glib::gobject_ffi::g_value_set_flags(value.to_glib_none_mut().0, self.into_glib());
        }
        value
    }

    #[inline]
    fn value_type(&self) -> glib::Type {
        Self::static_type()
    }
}

impl From<DataIdMatchFlags> for glib::Value {
    #[inline]
    fn from(v: DataIdMatchFlags) -> Self {
        skip_assert_initialized!();
        ToValue::to_value(&v)
    }
}

bitflags! {
    #[derive(Clone, Copy, Debug, PartialEq, Eq, Hash)]
    #[doc(alias = "AsParseFlags")]
    pub struct ParseFlags: u32 {
        #[doc(alias = "AS_PARSE_FLAG_NONE")]
        const NONE = ffi::AS_PARSE_FLAG_NONE as _;
        #[doc(alias = "AS_PARSE_FLAG_IGNORE_MEDIABASEURL")]
        const IGNORE_MEDIABASEURL = ffi::AS_PARSE_FLAG_IGNORE_MEDIABASEURL as _;
    }
}

#[doc(hidden)]
impl IntoGlib for ParseFlags {
    type GlibType = ffi::AsParseFlags;

    #[inline]
    fn into_glib(self) -> ffi::AsParseFlags {
        self.bits()
    }
}

#[doc(hidden)]
impl FromGlib<ffi::AsParseFlags> for ParseFlags {
    #[inline]
    unsafe fn from_glib(value: ffi::AsParseFlags) -> Self {
        skip_assert_initialized!();
        Self::from_bits_truncate(value)
    }
}

impl StaticType for ParseFlags {
    #[inline]
    #[doc(alias = "as_parse_flags_get_type")]
    fn static_type() -> glib::Type {
        unsafe { from_glib(ffi::as_parse_flags_get_type()) }
    }
}

impl glib::HasParamSpec for ParseFlags {
    type ParamSpec = glib::ParamSpecFlags;
    type SetValue = Self;
    type BuilderFn = fn(&str) -> glib::ParamSpecFlagsBuilder<Self>;

    fn param_spec_builder() -> Self::BuilderFn {
        Self::ParamSpec::builder
    }
}

impl glib::value::ValueType for ParseFlags {
    type Type = Self;
}

unsafe impl<'a> glib::value::FromValue<'a> for ParseFlags {
    type Checker = glib::value::GenericValueTypeChecker<Self>;

    #[inline]
    unsafe fn from_value(value: &'a glib::Value) -> Self {
        skip_assert_initialized!();
        from_glib(glib::gobject_ffi::g_value_get_flags(value.to_glib_none().0))
    }
}

impl ToValue for ParseFlags {
    #[inline]
    fn to_value(&self) -> glib::Value {
        let mut value = glib::Value::for_value_type::<Self>();
        unsafe {
            glib::gobject_ffi::g_value_set_flags(value.to_glib_none_mut().0, self.into_glib());
        }
        value
    }

    #[inline]
    fn value_type(&self) -> glib::Type {
        Self::static_type()
    }
}

impl From<ParseFlags> for glib::Value {
    #[inline]
    fn from(v: ParseFlags) -> Self {
        skip_assert_initialized!();
        ToValue::to_value(&v)
    }
}

bitflags! {
    #[derive(Clone, Copy, Debug, PartialEq, Eq, Hash)]
    #[doc(alias = "AsPoolFlags")]
    pub struct PoolFlags: u32 {
        #[doc(alias = "AS_POOL_FLAG_NONE")]
        const NONE = ffi::AS_POOL_FLAG_NONE as _;
        #[doc(alias = "AS_POOL_FLAG_LOAD_OS_CATALOG")]
        const LOAD_OS_CATALOG = ffi::AS_POOL_FLAG_LOAD_OS_CATALOG as _;
        #[doc(alias = "AS_POOL_FLAG_LOAD_OS_METAINFO")]
        const LOAD_OS_METAINFO = ffi::AS_POOL_FLAG_LOAD_OS_METAINFO as _;
        #[doc(alias = "AS_POOL_FLAG_LOAD_OS_DESKTOP_FILES")]
        const LOAD_OS_DESKTOP_FILES = ffi::AS_POOL_FLAG_LOAD_OS_DESKTOP_FILES as _;
        #[doc(alias = "AS_POOL_FLAG_LOAD_FLATPAK")]
        const LOAD_FLATPAK = ffi::AS_POOL_FLAG_LOAD_FLATPAK as _;
        #[doc(alias = "AS_POOL_FLAG_IGNORE_CACHE_AGE")]
        const IGNORE_CACHE_AGE = ffi::AS_POOL_FLAG_IGNORE_CACHE_AGE as _;
        #[doc(alias = "AS_POOL_FLAG_RESOLVE_ADDONS")]
        const RESOLVE_ADDONS = ffi::AS_POOL_FLAG_RESOLVE_ADDONS as _;
        #[doc(alias = "AS_POOL_FLAG_PREFER_OS_METAINFO")]
        const PREFER_OS_METAINFO = ffi::AS_POOL_FLAG_PREFER_OS_METAINFO as _;
        #[doc(alias = "AS_POOL_FLAG_MONITOR")]
        const MONITOR = ffi::AS_POOL_FLAG_MONITOR as _;
    }
}

#[doc(hidden)]
impl IntoGlib for PoolFlags {
    type GlibType = ffi::AsPoolFlags;

    #[inline]
    fn into_glib(self) -> ffi::AsPoolFlags {
        self.bits()
    }
}

#[doc(hidden)]
impl FromGlib<ffi::AsPoolFlags> for PoolFlags {
    #[inline]
    unsafe fn from_glib(value: ffi::AsPoolFlags) -> Self {
        skip_assert_initialized!();
        Self::from_bits_truncate(value)
    }
}

impl StaticType for PoolFlags {
    #[inline]
    #[doc(alias = "as_pool_flags_get_type")]
    fn static_type() -> glib::Type {
        unsafe { from_glib(ffi::as_pool_flags_get_type()) }
    }
}

impl glib::HasParamSpec for PoolFlags {
    type ParamSpec = glib::ParamSpecFlags;
    type SetValue = Self;
    type BuilderFn = fn(&str) -> glib::ParamSpecFlagsBuilder<Self>;

    fn param_spec_builder() -> Self::BuilderFn {
        Self::ParamSpec::builder
    }
}

impl glib::value::ValueType for PoolFlags {
    type Type = Self;
}

unsafe impl<'a> glib::value::FromValue<'a> for PoolFlags {
    type Checker = glib::value::GenericValueTypeChecker<Self>;

    #[inline]
    unsafe fn from_value(value: &'a glib::Value) -> Self {
        skip_assert_initialized!();
        from_glib(glib::gobject_ffi::g_value_get_flags(value.to_glib_none().0))
    }
}

impl ToValue for PoolFlags {
    #[inline]
    fn to_value(&self) -> glib::Value {
        let mut value = glib::Value::for_value_type::<Self>();
        unsafe {
            glib::gobject_ffi::g_value_set_flags(value.to_glib_none_mut().0, self.into_glib());
        }
        value
    }

    #[inline]
    fn value_type(&self) -> glib::Type {
        Self::static_type()
    }
}

impl From<PoolFlags> for glib::Value {
    #[inline]
    fn from(v: PoolFlags) -> Self {
        skip_assert_initialized!();
        ToValue::to_value(&v)
    }
}

bitflags! {
    #[derive(Clone, Copy, Debug, PartialEq, Eq, Hash)]
    #[doc(alias = "AsReviewFlags")]
    pub struct ReviewFlags: u32 {
        #[doc(alias = "AS_REVIEW_FLAG_NONE")]
        const NONE = ffi::AS_REVIEW_FLAG_NONE as _;
        #[doc(alias = "AS_REVIEW_FLAG_SELF")]
        const SELF = ffi::AS_REVIEW_FLAG_SELF as _;
        #[doc(alias = "AS_REVIEW_FLAG_VOTED")]
        const VOTED = ffi::AS_REVIEW_FLAG_VOTED as _;
    }
}

#[doc(hidden)]
impl IntoGlib for ReviewFlags {
    type GlibType = ffi::AsReviewFlags;

    #[inline]
    fn into_glib(self) -> ffi::AsReviewFlags {
        self.bits()
    }
}

#[doc(hidden)]
impl FromGlib<ffi::AsReviewFlags> for ReviewFlags {
    #[inline]
    unsafe fn from_glib(value: ffi::AsReviewFlags) -> Self {
        skip_assert_initialized!();
        Self::from_bits_truncate(value)
    }
}

impl StaticType for ReviewFlags {
    #[inline]
    #[doc(alias = "as_review_flags_get_type")]
    fn static_type() -> glib::Type {
        unsafe { from_glib(ffi::as_review_flags_get_type()) }
    }
}

impl glib::HasParamSpec for ReviewFlags {
    type ParamSpec = glib::ParamSpecFlags;
    type SetValue = Self;
    type BuilderFn = fn(&str) -> glib::ParamSpecFlagsBuilder<Self>;

    fn param_spec_builder() -> Self::BuilderFn {
        Self::ParamSpec::builder
    }
}

impl glib::value::ValueType for ReviewFlags {
    type Type = Self;
}

unsafe impl<'a> glib::value::FromValue<'a> for ReviewFlags {
    type Checker = glib::value::GenericValueTypeChecker<Self>;

    #[inline]
    unsafe fn from_value(value: &'a glib::Value) -> Self {
        skip_assert_initialized!();
        from_glib(glib::gobject_ffi::g_value_get_flags(value.to_glib_none().0))
    }
}

impl ToValue for ReviewFlags {
    #[inline]
    fn to_value(&self) -> glib::Value {
        let mut value = glib::Value::for_value_type::<Self>();
        unsafe {
            glib::gobject_ffi::g_value_set_flags(value.to_glib_none_mut().0, self.into_glib());
        }
        value
    }

    #[inline]
    fn value_type(&self) -> glib::Type {
        Self::static_type()
    }
}

impl From<ReviewFlags> for glib::Value {
    #[inline]
    fn from(v: ReviewFlags) -> Self {
        skip_assert_initialized!();
        ToValue::to_value(&v)
    }
}

bitflags! {
    #[derive(Clone, Copy, Debug, PartialEq, Eq, Hash)]
    #[doc(alias = "AsValueFlags")]
    pub struct ValueFlags: u32 {
        #[doc(alias = "AS_VALUE_FLAG_NONE")]
        const NONE = ffi::AS_VALUE_FLAG_NONE as _;
        #[doc(alias = "AS_VALUE_FLAG_DUPLICATE_CHECK")]
        const DUPLICATE_CHECK = ffi::AS_VALUE_FLAG_DUPLICATE_CHECK as _;
        #[doc(alias = "AS_VALUE_FLAG_NO_TRANSLATION_FALLBACK")]
        const NO_TRANSLATION_FALLBACK = ffi::AS_VALUE_FLAG_NO_TRANSLATION_FALLBACK as _;
    }
}

#[doc(hidden)]
impl IntoGlib for ValueFlags {
    type GlibType = ffi::AsValueFlags;

    #[inline]
    fn into_glib(self) -> ffi::AsValueFlags {
        self.bits()
    }
}

#[doc(hidden)]
impl FromGlib<ffi::AsValueFlags> for ValueFlags {
    #[inline]
    unsafe fn from_glib(value: ffi::AsValueFlags) -> Self {
        skip_assert_initialized!();
        Self::from_bits_truncate(value)
    }
}

impl StaticType for ValueFlags {
    #[inline]
    #[doc(alias = "as_value_flags_get_type")]
    fn static_type() -> glib::Type {
        unsafe { from_glib(ffi::as_value_flags_get_type()) }
    }
}

impl glib::HasParamSpec for ValueFlags {
    type ParamSpec = glib::ParamSpecFlags;
    type SetValue = Self;
    type BuilderFn = fn(&str) -> glib::ParamSpecFlagsBuilder<Self>;

    fn param_spec_builder() -> Self::BuilderFn {
        Self::ParamSpec::builder
    }
}

impl glib::value::ValueType for ValueFlags {
    type Type = Self;
}

unsafe impl<'a> glib::value::FromValue<'a> for ValueFlags {
    type Checker = glib::value::GenericValueTypeChecker<Self>;

    #[inline]
    unsafe fn from_value(value: &'a glib::Value) -> Self {
        skip_assert_initialized!();
        from_glib(glib::gobject_ffi::g_value_get_flags(value.to_glib_none().0))
    }
}

impl ToValue for ValueFlags {
    #[inline]
    fn to_value(&self) -> glib::Value {
        let mut value = glib::Value::for_value_type::<Self>();
        unsafe {
            glib::gobject_ffi::g_value_set_flags(value.to_glib_none_mut().0, self.into_glib());
        }
        value
    }

    #[inline]
    fn value_type(&self) -> glib::Type {
        Self::static_type()
    }
}

impl From<ValueFlags> for glib::Value {
    #[inline]
    fn from(v: ValueFlags) -> Self {
        skip_assert_initialized!();
        ToValue::to_value(&v)
    }
}

bitflags! {
    #[derive(Clone, Copy, Debug, PartialEq, Eq, Hash)]
    #[doc(alias = "AsVercmpFlags")]
    pub struct VercmpFlags: u32 {
        #[doc(alias = "AS_VERCMP_FLAG_NONE")]
        const NONE = ffi::AS_VERCMP_FLAG_NONE as _;
        #[doc(alias = "AS_VERCMP_FLAG_IGNORE_EPOCH")]
        const IGNORE_EPOCH = ffi::AS_VERCMP_FLAG_IGNORE_EPOCH as _;
    }
}

#[doc(hidden)]
impl IntoGlib for VercmpFlags {
    type GlibType = ffi::AsVercmpFlags;

    #[inline]
    fn into_glib(self) -> ffi::AsVercmpFlags {
        self.bits()
    }
}

#[doc(hidden)]
impl FromGlib<ffi::AsVercmpFlags> for VercmpFlags {
    #[inline]
    unsafe fn from_glib(value: ffi::AsVercmpFlags) -> Self {
        skip_assert_initialized!();
        Self::from_bits_truncate(value)
    }
}

impl StaticType for VercmpFlags {
    #[inline]
    #[doc(alias = "as_vercmp_flags_get_type")]
    fn static_type() -> glib::Type {
        unsafe { from_glib(ffi::as_vercmp_flags_get_type()) }
    }
}

impl glib::HasParamSpec for VercmpFlags {
    type ParamSpec = glib::ParamSpecFlags;
    type SetValue = Self;
    type BuilderFn = fn(&str) -> glib::ParamSpecFlagsBuilder<Self>;

    fn param_spec_builder() -> Self::BuilderFn {
        Self::ParamSpec::builder
    }
}

impl glib::value::ValueType for VercmpFlags {
    type Type = Self;
}

unsafe impl<'a> glib::value::FromValue<'a> for VercmpFlags {
    type Checker = glib::value::GenericValueTypeChecker<Self>;

    #[inline]
    unsafe fn from_value(value: &'a glib::Value) -> Self {
        skip_assert_initialized!();
        from_glib(glib::gobject_ffi::g_value_get_flags(value.to_glib_none().0))
    }
}

impl ToValue for VercmpFlags {
    #[inline]
    fn to_value(&self) -> glib::Value {
        let mut value = glib::Value::for_value_type::<Self>();
        unsafe {
            glib::gobject_ffi::g_value_set_flags(value.to_glib_none_mut().0, self.into_glib());
        }
        value
    }

    #[inline]
    fn value_type(&self) -> glib::Type {
        Self::static_type()
    }
}

impl From<VercmpFlags> for glib::Value {
    #[inline]
    fn from(v: VercmpFlags) -> Self {
        skip_assert_initialized!();
        ToValue::to_value(&v)
    }
}
